unit BattleShips;

{ BattleShips 1991 Rhys Hollow}
{This Rulebook and its source are both PovertyWare}

interface

	uses
		GameTypes, Debugs, DialogSubs, BattleShipsTypes, BattleShipsDraw;

	procedure Main (var gameevent: gameEventRecord);

implementation

	procedure Main (var gameevent: gameEventRecord);

		var
			g: gamePeek;
			gl: globalsHandle;

		procedure InitGame;
			var
				i: integer;
				b: boatType;
				mygl: globalsPeek;
		begin
			gameevent.globals := NewHandle(sizeof(globalsRecord));
			gameevent.int1 := windwidth;
			gameevent.int2 := windheight;
			HLock(gameevent.globals);
			mygl := globalsPeek(gameevent.globals^);
			with mygl^ do begin
				StuffHex(@grey, 'AA55AA55AA55AA55');
				for i := fireID to connectmeID do begin
					cards[i] := GetPicture(i);
				end;
				shell := GetPicture(shellID);
				for b := bt_None to bt_Tug do begin
					for i := 1 to 5 do begin
						pieces[b, true, true, i] := nil;
						pieces[b, true, false, i] := nil;
						pieces[b, false, true, i] := nil;
						pieces[b, false, false, i] := nil;
					end;
				end;

				for i := 0 to 4 do begin
					pieces[bt_Carrier, true, false, i + 1] := GetPicture(hcarrierbuttonID + i);
					pieces[bt_Carrier, false, false, i + 1] := GetPicture(hcarrierspaceID + i);
					pieces[bt_Carrier, true, true, i + 1] := GetPicture(vcarrierbuttonID + i);
					pieces[bt_Carrier, false, true, i + 1] := GetPicture(vcarrierspaceID + i);
				end;

				for i := 0 to 3 do begin
					pieces[bt_BattleShip, true, false, i + 1] := GetPicture(hbattleshipbuttonID + i);
					pieces[bt_BattleShip, false, false, i + 1] := GetPicture(hbattleshipspaceID + i);
					pieces[bt_BattleShip, true, true, i + 1] := GetPicture(vbattleshipbuttonID + i);
					pieces[bt_BattleShip, false, true, i + 1] := GetPicture(vbattleshipspaceID + i);
				end;

				for i := 0 to 2 do begin
					pieces[bt_Destroyer, true, false, i + 1] := GetPicture(hdestroyerbuttonID + i);
					pieces[bt_Destroyer, false, false, i + 1] := GetPicture(hdestroyerspaceID + i);
					pieces[bt_Destroyer, true, true, i + 1] := GetPicture(vdestroyerbuttonID + i);
					pieces[bt_Destroyer, false, true, i + 1] := GetPicture(vdestroyerspaceID + i);

					pieces[bt_Submarine, true, false, i + 1] := GetPicture(hsubbuttonID + i);
					pieces[bt_Submarine, false, false, i + 1] := GetPicture(hsubspaceID + i);
					pieces[bt_Submarine, true, true, i + 1] := GetPicture(vsubbuttonID + i);
					pieces[bt_Submarine, false, true, i + 1] := GetPicture(vsubspaceID + i);
				end;

				for i := 0 to 1 do begin
					pieces[bt_Tug, true, false, i + 1] := GetPicture(htugbuttonID + i);
					pieces[bt_Tug, false, false, i + 1] := GetPicture(htugspaceID + i);
					pieces[bt_Tug, true, true, i + 1] := GetPicture(vtugbuttonID + i);
					pieces[bt_Tug, false, true, i + 1] := GetPicture(vtugspaceID + i);
				end;
				for i := 0 to 4 do begin
					pieces[bt_None, true, false, 1 + i] := GetPicture(buttonID);
					pieces[bt_None, false, false, 1 + i] := GetPicture(spaceID);

					pieces[bt_Mystery, true, false, 1 + i] := GetPicture(mysteryID);
					pieces[bt_Mystery, true, true, 1 + i] := GetPicture(mysteryID);

					pieces[bt_BlownUp, false, true, 1 + i] := GetPicture(blownupID);
					pieces[bt_BlownUp, false, false, 1 + i] := GetPicture(blownupID);
				end;

			end;
		end;

		procedure FinishGame;
		begin
			DisposHandle(gameevent.globals);
			gameevent.globals := nil;
		end;

		procedure UpdateMenus;
		begin
		end;

		procedure MyShowControl (c: controlHandle);
		begin
			SetCRefCon(c, 1);
			ShowControl(c);
		end;

		procedure MyHideControl (c: controlHandle);
		begin
			SetCRefCon(c, 0);
			HideControl(c);
		end;


		procedure IncomingTurn;
			var
				i: integer;
		begin
			g^.gametest := false;
			g^.gamestate := gs_Incoming;
			g^.shots := maxshots;
			PostCard(g, 0, incomingID);
			for i := 1 to g^.shots do begin
				DrawShell(g, i, 11, true);
			end;
			SetCTitle(g^.control, 'OK');
			MoveControl(g^.control, hiscontrolx, hiscontroly);
			gameevent.myturn := false;
		end;

		procedure FireTurn;
			var
				i: integer;
		begin
			g^.gamestate := gs_Firing;
			g^.shots := maxshots;
			PostCard(g, fireID, 0);
			for i := 1 to g^.shots do begin
				DrawShell(g, i, 0, true);
			end;
			SetCTitle(g^.control, 'Fire');
			MoveControl(g^.control, mycontrolx, mycontroly);
			gameevent.myturn := true;
		end;

		procedure Activate;
		begin
		end;

		procedure Deactivate;
		begin
		end;

		procedure CommonInit;
			var
				savport: GrafPtr;
		begin
			GetPort(savport);
			SetDHandle(savport, useritemID, Handle(@Draw));
			WindowPeek(savport)^.refcon := longint(gameevent.game);
			g^.globals := globalsHandle(gl);
			g^.doit := false;
		end;

		procedure NewGame;
			var
				i: integer;
				x, y: integer;
				bt: boatType;
				hstate: SignedByte;
		begin
			SetHandleSize(Handle(gameevent.game), sizeof(gameRecord));
			hstate := HGetState(Handle(gameevent.game));
			HLock(Handle(gameevent.game));
			g := gamePeek(Handle(gameevent.game)^);
			CommonInit;
			with g^ do begin
				for y := 0 to 9 do begin
					for x := 0 to 9 do begin
						with myboard[x, y] do begin
							hidden := true;
							mystery := false;
							boat := bt_None;
							piece := 1;
						end;
						with hisboard[x, y] do begin
							hidden := true;
							mystery := false;
							boat := bt_None;
							piece := 1;
						end;
					end;
				end;
				gametest := false;
				minelast := 0;
				hislast := connectmeID;
				shots := maxshots;
				mymove := true;
				control := nil;
				gamestate := gs_ConnectMe;
				for bt := bt_None to bt_Tug do begin
					for i := 1 to 5 do begin
						ships[bt].damaged[i] := false;
					end;
					ships[bt].vert := false;
					ships[bt].destroyed := false;
				end;
				with ships[bt_None] do begin
					docked := false;
					vert := false;
					boatlength := 1;
				end;
				with ships[bt_Mystery] do begin
					docked := false;
					vert := false;
					boatlength := 1;
				end;
				with ships[bt_BlownUp] do begin
					docked := false;
					vert := false;
					boatlength := 1;
				end;
				with ships[bt_Carrier] do begin
					docked := true;
					vert := false;
					boatlength := 5;
					dockx := 0;
					x := 0;
					y := 11;
				end;
				with ships[bt_BattleShip] do begin
					docked := true;
					vert := false;
					boatlength := 4;
					dockx := 6;
					x := 6;
					y := 11;
				end;
				with ships[bt_Destroyer] do begin
					docked := true;
					vert := false;
					boatlength := 3;
					dockx := 11;
					x := 11;
					y := 11;
				end;
				with ships[bt_Submarine] do begin
					docked := true;
					vert := false;
					boatlength := 3;
					dockx := 15;
					x := 15;
					y := 11;
				end;
				with ships[bt_Tug] do begin
					docked := true;
					vert := false;
					boatlength := 2;
					dockx := 19;
					x := 19;
					y := 11;
				end;
				hisships := ships;
			end;
			gameevent.myturn := true;
		end;

		procedure OldGame;
		begin
			CommonInit;
			gameevent.myturn := true;
		end;

		procedure ConnectionLost;
			var
				savport: GrafPtr;
		begin
			GetPort(savport);
			PostCard(g, 0, 0);
			DisposeControl(g^.control);
			NewGame;
			g^.hislast := 0;
			Draw(savport, useritemID);
			PostCard(g, 0, connectmeID);
		end;

		procedure ConnectionMade;
			var
				savport: GrafPtr;
		begin
			g^.gamestate := gs_PlaceMe;
			PostCard(g, 0, posfleetID);
			GetPort(savport);
			g^.control := GetNewControl(controlID, savport);
			MoveControl(g^.control, poscontrolx, poscontroly);
			SetCTitle(g^.control, 'Sail');
			HiliteControl(g^.control, 255);
			MyShowControl(g^.control);
			gameevent.myturn := true;
		end;

		procedure PlaceBoat (pt, bt: boatType; var board: boardType; off, x, y: integer; vert: boolean);
			var
				i: integer;
				dx, dy: integer;
		begin
			if (pt <> bt_None) then
				if off = 11 then begin
					g^.hisships[bt].x := x;
					g^.hisships[bt].y := y;
				end
				else begin
					g^.ships[bt].x := x;
					g^.ships[bt].y := y;
				end;
			dy := 0;
			dx := 0;
			if vert then
				dy := 1
			else
				dx := 1;
			for i := 0 to g^.ships[bt].boatlength - 1 do begin
				board[x, y].boat := pt;
				if pt = bt_None then
					board[x, y].piece := 1
				else
					board[x, y].piece := i + 1;
				if (off <> 11) or ((off = 11) and g^.hisships[bt].destroyed) then
					DrawPiece(g, x + off, y, board[x, y]);
				x := x + dx;
				y := y + dy;
			end;
		end;

		procedure GetSquare (pt: point; var x, y: integer);
		begin
			pt.h := pt.h + gridsize;
			pt.v := pt.v + gridsize;
			x := (pt.h - boardx) div gridsize;
			y := (pt.v - boardy) div gridsize;
			x := x - 1;
			y := y - 1;
		end;

		function CheckSquare (bt: boatType; x, y: integer; vert: boolean): boolean;
			var
				dummy: boolean;
				i: integer;
		begin
			if (x < 0) or (x > 9) or (y < 0) or (y > 9) then begin
				CheckSquare := false;
				exit(CheckSquare);
			end;
			dummy := true;
			if vert then begin
				for i := y to y + g^.ships[bt].boatlength - 1 do begin
					if not (i in [0..9]) then
						dummy := false
					else if not (g^.myboard[x, i].boat in [bt_None, bt]) then
						dummy := false;
				end;
			end
			else begin
				for i := x to x + g^.ships[bt].boatlength - 1 do begin
					if not (i in [0..9]) then
						dummy := false
					else if not (g^.myboard[i, y].boat in [bt_None, bt]) then
						dummy := false;
				end;
			end;
			CheckSquare := dummy;
		end;

		procedure TugBoat (bt: boatType);
			const
				shiftkey = 56;
			var
				overt, tvert, lvert, valid, isdown: boolean;
				km: KeyMap;
				ps: PenState;
				boatrect, dockrect, boardrect: rect;
				thispt, lastpt: point;
				tx, ty, lx, ly: integer;
				tmp: integer;
				xoff, yoff, gxoff, gyoff: integer;
				noneleft: boolean;
				savport: GrafPtr;
				mybt: boatType;
		begin
			if bt <> bt_None then begin
				GetPort(savport);
				GetKeys(km);
				isdown := km[shiftkey];
				overt := g^.ships[bt].vert;
				lvert := overt;
				tvert := lvert;
				lx := g^.ships[bt].x;
				ly := g^.ships[bt].y;
				GetMouse(lastpt);
				dockrect := GetRect(g^.ships[bt].dockx, 11);
				dockrect.right := dockrect.left + g^.ships[bt].boatlength * gridsize;
				boardrect.top := boardy;
				boardrect.left := boardx;
				boardrect.bottom := boardrect.top + 10 * gridsize;
				boardrect.right := boardrect.left + 10 * gridsize;
				GetSquare(lastpt, tx, ty);
				gxoff := tx - lx;
				gyoff := ty - ly;
				GetPenState(ps);
				PenPat(gl^^.grey);
				PenSize(2, 2);
				PenMode(patXor);
				boatrect := GetBoatRect(g, bt, g^.ships[bt].x, g^.ships[bt].y, overt);
				FrameRect(boatrect);
				xoff := lastpt.h - boatrect.left;
				yoff := lastpt.v - boatrect.top;
				while button do begin
					GetKeys(km);
					if km[shiftkey] and not isdown then
						tvert := not tvert;
					isdown := km[shiftkey];
					if tvert <> lvert then begin
						FrameRect(boatrect);
						if ly <> 11 then begin
							DrawBoat(g, bt_None, bt, lx, ly, lvert);
						end;
						if tvert then begin
							tmp := yoff;
							yoff := xoff;
							xoff := gridsize - tmp;
						end
						else begin
							tmp := xoff;
							xoff := yoff;
							yoff := gridsize - tmp;
						end;
						boatrect := GetBoatRect(g, bt, 0, 0, tvert);
						OffsetRect(boatrect, -boatrect.left + lastpt.h - xoff, -boatrect.top + lastpt.v - yoff);

{undrawn old ship and frame, built new frame and x,yoff}
{new gx,yoff}

						if tvert then begin
							gyoff := gxoff;
							gxoff := 0;
						end
						else begin
							gxoff := gyoff;
							gyoff := 0;
						end;
						GetSquare(lastpt, tx, ty);
						tx := tx - gxoff;
						ty := ty - gyoff;
{now draw new one}
						if not CheckSquare(bt, tx, ty, tvert) then begin
							tx := g^.ships[bt].dockx;
							ty := 11;
							if ly <> 11 then
								DrawBoat(g, bt, bt, tx, ty, false);
						end
						else begin
							if ly = 11 then
								EraseRect(dockrect);
							DrawBoat(g, bt, bt, tx, ty, tvert);
						end;
						FrameRect(boatrect);
						lx := tx;
						ly := ty;
						lvert := tvert;
					end
					else begin
						GetMouse(thispt);
						if (thispt.h <> lastpt.h) or (thispt.v <> lastpt.v) then begin
							FrameRect(boatrect);
							GetSquare(thispt, tx, ty);
							tx := tx - gxoff;
							ty := ty - gyoff;
							valid := CheckSquare(bt, tx, ty, lvert);
							if valid and ((tx <> lx) or (ty <> ly)) then begin
								if ly = 11 then begin
									EraseRect(dockrect);
								end
								else begin
									DrawBoat(g, bt_None, bt, lx, ly, lvert);
								end;
								DrawBoat(g, bt, bt, tx, ty, lvert);
								lx := tx;
								ly := ty;
							end
							else if (ly <> 11) and not valid then begin
								DrawBoat(g, bt_None, bt, lx, ly, lvert);
								ly := 11;
								lx := g^.ships[bt].dockx;
								DrawBoat(g, bt, bt, lx, ly, false);
							end;
							OffsetRect(boatrect, -boatrect.left + thispt.h - xoff, -boatrect.top + thispt.v - yoff);
							FrameRect(boatrect);
							lastpt := thispt;
						end;
					end;
				end; {while}
				FrameRect(boatrect);
				SetPenState(ps);

				if not (g^.ships[bt].docked and (ly = 11)) and not ((g^.ships[bt].x = lx) and (g^.ships[bt].y = ly) and (lvert = g^.ships[bt].vert)) then begin
					if g^.ships[bt].docked then begin
						g^.ships[bt].docked := false;
						g^.ships[bt].vert := lvert;
						PlaceBoat(bt, bt, g^.myboard, 0, lx, ly, lvert);
					end
					else if ((overt <> lvert) or (lx <> g^.ships[bt].x) or (ly <> g^.ships[bt].y)) and (ly <> 11) then begin
						PlaceBoat(bt_None, bt, g^.myboard, 0, g^.ships[bt].x, g^.ships[bt].y, overt);
						g^.ships[bt].vert := lvert;
						PlaceBoat(bt, bt, g^.myboard, 0, lx, ly, lvert);
					end
					else if ly = 11 then begin
						PlaceBoat(bt_None, bt, g^.myboard, 0, g^.ships[bt].x, g^.ships[bt].y, overt);
						g^.ships[bt].docked := true;
						g^.ships[bt].x := g^.ships[bt].dockx;
						g^.ships[bt].vert := false;
						g^.ships[bt].y := 11;
					end;
				end;

				noneleft := true;
				for mybt := bt_Carrier to bt_Tug do begin
					if g^.ships[mybt].docked then
						noneleft := false;
				end;
				if noneleft then begin
					HiliteControl(g^.control, 0);
				end
				else begin
					HiliteControl(g^.control, 255);
				end;
			end;
		end;

		procedure PlaceShell (x, y, off: integer; var board: boardType);
			var
				savport: GrafPtr;
		begin
			GetPort(savport);
			if board[x, y].mystery then begin
				g^.shots := g^.shots + 1;
				DrawShell(g, g^.shots, -(off - 11), true);
			end
			else begin
				DrawShell(g, g^.shots, -(off - 11), false);
				g^.shots := g^.shots - 1;
			end;
			board[x, y].mystery := not board[x, y].mystery;
			DrawPiece(g, x + off, y, board[x, y]);
			if off = 11 then begin
				if g^.shots = 0 then begin
					MyShowControl(g^.control);
				end
				else begin
					MyHideControl(g^.control);
				end;
			end;
		end;

		procedure FireShell (x, y: integer);
			var
				thispt: point;
				myst: boolean;
				p: pieceType;
				izin: boolean;
				r: rect;
		begin
			p := g^.hisboard[x - 11, y];
			if (p.hidden and (g^.shots > 0)) or (p.mystery) then begin
				r := GetRect(x, y);
				p.mystery := not p.mystery;
				DrawPiece(g, x, y, p);
				izin := true;
				while Button do begin
					GetMouse(thispt);
					if PtInRect(thispt, r) then begin
						if not izin then begin
							izin := true;
							p.mystery := not p.mystery;
							DrawPiece(g, x, y, p);
						end;
					end
					else if izin then begin
						izin := false;
						p.mystery := not p.mystery;
						DrawPiece(g, x, y, p);
					end;
				end;
				if izin then begin
					PlaceShell(x - 11, y, 11, g^.hisboard);
					gameevent.message := concat(chr(x - 11 + ord('0')), chr(y + ord('0')));
					gameevent.event := ge_SendMessage;
				end;
			end;
		end;

		procedure RevealShips (off: integer; var board: boardType; var ships: shipArray);
			var
				x, y: integer;
				f: longint;
				bt: boatType;
				p: pieceType;
				isdead: boolean;
				i: integer;
		begin
			for y := 0 to 9 do begin
				for x := 0 to 9 do begin
					if board[x, y].mystery then begin
						board[x, y].mystery := false;
						board[x, y].hidden := false;
						bt := board[x, y].boat;
						if bt <> bt_None then begin
							ships[bt].damaged[board[x, y].piece] := true;
							p := board[x, y];
							p.hidden := true;
							if off = 11 then
								board[x, y].boat := bt_BlownUp
							else
								DrawPiece(g, ships[bt].dockx + board[x, y].piece - 1, 11, p);
						end;
						DrawPiece(g, x + off, y, board[x, y]);
						if ships[bt].damaged[board[x, y].piece] then begin
							isdead := true;
							for i := 1 to ships[bt].boatlength do begin
								if not ships[bt].damaged[i] then
									isdead := false;
							end;
							if isdead then begin
								ships[bt].destroyed := true;
								for i := 1 to 3 do begin
									PlaceBoat(bt_BlownUp, bt, board, off, ships[bt].x, ships[bt].y, ships[bt].vert);
									Delay(10, f);
									PlaceBoat(bt, bt, board, off, ships[bt].x, ships[bt].y, ships[bt].vert);
									Delay(10, f);
								end;
							end;
						end;
						Delay(40, f);
					end;
				end;
			end;
			isdead := true;
			for bt := bt_Carrier to bt_Tug do begin
				if not ships[bt].destroyed then
					isdead := false;
			end;
			if not isdead then begin
				if off = 11 then begin
					SetCTitle(g^.control, 'OK');
					MyShowControl(g^.control);
					g^.gamestate := gs_FWait;
				end
				else begin
					if g^.gametest then begin
						SetCTitle(g^.control, 'OK');
						MyShowControl(g^.control);
						gameevent.myturn := true;
					end
					else
						g^.gamestate := gs_IWait;
				end;
			end
			else begin
				if off = 11 then begin
					PostCard(g, enemysunkID, 0);
				end
				else begin
					PostCard(g, 0, fleetlostID);
				end;
			end;
		end;

		procedure GameRestart;
			var
				tmpturn: boolean;
				savport: GrafPtr;
		begin
			GetPort(savport);
			PostCard(g, 0, 0);
			tmpturn := g^.mymove;
			DisposeControl(g^.control);
			HUnlock(Handle(gameevent.game));
			SetHandleSize(Handle(gameevent.game), 0);
			NewGame;
			g^.hislast := 0;
			Draw(savport, useritemID);
			g^.gamestate := gs_PlaceMe;
			PostCard(g, 0, posfleetID);
			gameevent.myturn := true;
			g^.mymove := not tmpturn;
			g^.control := GetNewControl(controlID, savport);
			MoveControl(g^.control, poscontrolx, poscontroly);
			SetCTitle(g^.control, 'Sail');
			HiliteControl(g^.control, 255);
			MyShowControl(g^.control);
		end;

		procedure DoIdle;
		begin
			if g^.doit then begin
				g^.doit := false;
				RevealShips(11, g^.hisboard, g^.hisships);
			end;
		end;

		procedure MouseDown;
			var
				i, x, y: integer;
				bt: boatType;
				savport: GrafPtr;
				conthand: ControlHandle;
				where: integer;
				f: longint;
				str: str255;
		begin
			GetPort(savport);
			where := FindControl(gameevent.where, savport, conthand);
			if where <> 0 then begin
				if TrackControl(conthand, gameevent.where, nil) <> 0 then begin
					MyHideControl(conthand);
					case g^.gamestate of
						gs_PlaceMe:  begin
							gameevent.event := ge_SendMessage;
							str := '';
							for bt := bt_Carrier to bt_Tug do begin
								str := concat(str, chr(ord('0') + g^.ships[bt].x), chr(ord('0') + g^.ships[bt].y));
								if g^.ships[bt].vert then
									str := concat(str, 'v')
								else
									str := concat(str, 'h');
							end;
							gameevent.message := str;
							if not g^.gametest then begin
								PostCard(g, 0, pleasewaitID);
								g^.gamestate := gs_WFDocking;
								gameevent.myturn := false;
							end
							else if g^.mymove then begin
								FireTurn;
							end
							else begin
								IncomingTurn;
							end;
						end;
						gs_Firing:  begin
							gameevent.event := ge_SendMessage;
							gameevent.message := 'Fire';
							g^.doit := true;
						end;
						gs_FWait:  begin
							IncomingTurn;
							gameevent.message := 'Done';
							gameevent.event := ge_SendMessage;
						end;
						gs_Incoming: 
							FireTurn;
						gs_IWonWait:  begin
							PostCard(g, pleasewaitID, 0);
							g^.gamestate := gs_Resync;
							gameevent.event := ge_SendMessage;
							gameevent.message := 'Done';
						end;
						gs_ILostWait:  begin
							GameRestart;
							gameevent.message := 'Resync';
							gameevent.event := ge_SendMessage;
						end;
						otherwise
					end;

				end;
			end
			else begin
				case g^.gamestate of
					gs_PlaceMe:  begin
						bt := bt_None;
						GetSquare(gameevent.where, x, y);
						if ((x in [0..9]) and (y in [0..9])) then begin
							bt := g^.myboard[x, y].boat;
						end
						else if (y = 11) then begin
							case x of
								0..4: 
									if g^.ships[bt_Carrier].docked then
										bt := bt_Carrier;
								6..9: 
									if g^.ships[bt_BattleShip].docked then
										bt := bt_BattleShip;
								11..13: 
									if g^.ships[bt_Destroyer].docked then
										bt := bt_Destroyer;
								15..17: 
									if g^.ships[bt_Submarine].docked then
										bt := bt_Submarine;
								19..20: 
									if g^.ships[bt_Tug].docked then
										bt := bt_Tug;
								otherwise
							end;
						end;
						TugBoat(bt);


					end;
					gs_Firing:  begin
						GetSquare(gameevent.where, x, y);
						if (x >= 0) and (y >= 0) and (x in [11..20]) and (y in [0..9]) then begin
							FireShell(x, y);
						end;
					end;

					otherwise
				end;
			end;
		end;

		procedure Menu;
		begin
		end;

		procedure Restart;
		begin
			if g^.gamestate <> gs_ConnectMe then
				GameRestart;
		end;

		procedure Swap;
			var
				tmpb: boardType;
		begin
			if g^.gamestate in [gs_ConnectMe] then begin
				g^.mymove := not g^.mymove;
				tmpb := g^.myboard;
				g^.myboard := g^.hisboard;
				g^.hisboard := tmpb;
				gameevent.myturn := true;
			end;
		end;

		procedure KeyDown;
		begin
		end;

		procedure MessageReceived;
			var
				str: str255;
				i: integer;
				bt: boatType;
		begin
			str := gameevent.message;
			case g^.gamestate of
				gs_PlaceMe, gs_WFDocking:  begin
					i := 1;
					for bt := bt_Carrier to bt_Tug do begin
						g^.hisships[bt].vert := str[i + 2] = 'v';
						g^.hisships[bt].docked := false;
						PlaceBoat(bt, bt, g^.hisboard, 11, ord(str[i]) - ord('0'), ord(str[i + 1]) - ord('0'), str[i + 2] = 'v');
						i := i + 3;
					end;
					g^.gametest := true;
					if g^.gamestate = gs_WFDocking then begin
						if g^.mymove then begin
							FireTurn;
						end
						else begin
							IncomingTurn;
						end;
					end;
				end;
				gs_ILostWait: 
					if Pos(str, 'Done') <> 0 then begin
						SetCTitle(g^.control, 'Play');
						MyShowControl(g^.control);
						gameevent.myturn := true;
					end;
				gs_Resync: 
					if Pos(str, 'Resync') <> 0 then begin
						GameRestart;
					end;
				gs_Incoming, gs_IWait:  begin
					if Pos(str, 'Fire') <> 0 then begin
						RevealShips(0, g^.myboard, g^.ships);
					end
					else if Pos(str, 'Done') <> 0 then begin
						g^.gametest := true;
						if g^.gamestate = gs_IWait then begin
							g^.gamestate := gs_Incoming;
							SetCTitle(g^.control, 'OK');
							MyShowControl(g^.control);
							gameevent.myturn := true;
						end;
					end
					else begin
						PlaceShell(ord(str[1]) - ord('0'), ord(str[2]) - ord('0'), 0, g^.myboard);
					end;
				end;
				otherwise
			end;
		end;

	begin
		if (gameevent.game <> nil) and (gameevent.event <> ge_NewGame) then begin
			HLock(gameevent.game);
			g := gamePeek(gameevent.game^);
		end;
		if (gameevent.globals <> nil) then begin
			HLock(gameevent.globals);
			gl := globalsHandle(gameevent.globals);
		end;
		case gameevent.event of
			ge_InitRuleBook: 
				InitGame;
			ge_FinishRuleBook: 
				FinishGame;
			ge_UpdateMenus: 
				UpdateMenus;
			ge_Activate: 
				Activate;
			ge_Deactivate: 
				Deactivate;
			ge_NewGame: 
				NewGame;
			ge_OldGame: 
				OldGame;
			ge_ConnectionLost: 
				ConnectionLost;
			ge_ConnectionMade: 
				ConnectionMade;
			ge_MessageReceived: 
				MessageReceived;
			ge_Idle: 
				DoIdle;
			ge_MouseDown: 
				MouseDown;
			ge_Menu: 
				Menu;
			ge_Swap: 
				Swap;
			ge_Restart: 
				Restart;
			ge_KeyDown: 
				KeyDown;
			ge_Answer: 
				;
			otherwise
		end;
		if (gameevent.game <> nil) and (gameevent.event <> ge_NewGame) then
			HUnlock(gameevent.game);
		if (gameevent.globals <> nil) then
			HUnlock(gameevent.globals);
	end;

end.