unit ChessTypes;

{ 1991 Quinn "The Eskimo" }

interface

	type
		rectPtr = ^Rect;
		rectHandle = ^rectPtr;
	const
		kBoardXMax = 7;
		kBoardYMax = 7;

		kPawningX = 2;
		kPawningXMax = kPawningX + 3;
		kPawningY = 3;
		kPawningXBorder = 3;
		kPawningYBorder = 3;

		kCellXSize = 32;
		kCellYSize = 32;
		kCellXPitch = 33;
		kCellYPitch = 33;

		kMorgueMax = 15;
		kMorgueXMax = 7;
		kMorgueYMax = 2;
		kMorgueXSize = 16;
		kMorgueYSize = 16;
		kMorgueXPitch = 16;
		kMorgueYPitch = 16;
	type
		boardXNdx = 0..kBoardXMax;
		boardYNdx = 0..kBoardYMax;
		boardCoord = record
				x: boardXNdx;
				y: boardYNdx;
			end;
		morgueNdx = 1..kMorgueMax;
		cellColour = (Cwhite, Cblack);
		playerType = (Pblack, Pwhite);
		pieceType = (Oempty, {}
			OpawnB, OrookB, OknightB, ObishopB, OkingB, OqueenB, {}
			OpawnW, OrookW, OknightW, ObishopW, OkingW, OqueenW);
		pieceSet = set of pieceType;
		boardCell = record
				colour: cellColour;
				occupant: pieceType;
			end;
		boardType = array[boardXNdx, boardYNdx] of boardCell;
		boardSet = array[boardXNdx, boardYNdx] of boolean;

	type
		playStateType = (ps_Playing, ps_Pawning, ps_GameOver);
		connectionStateType = (cs_Local, cs_Remote);

		globalsPeek = ^globalsPtr;
		globalsPtr = ^globalsRecord;
		globalsRecord = record
				icons: array[cellColour, pieceType] of handle;
				waitpicts: array[playerType] of handle;
				movepicts: array[playerType] of handle;
				resignpicts: array[playerType] of handle;
				winpicts: array[playerType] of handle;
				pawnpicts: array[playerType] of handle;
				deadicons: handle;
				chessmenu: MenuHandle;
				pawnpieces: array[kPawningX..kPawningXMax] of pieceType;
				checksnd: handle;
				matesnd: handle;
			end;

		deathList = array[morgueNdx] of pieceType;
	type
		playerState = record
				cancastleleft, cancastleright: boolean;
				canevilpawn: boolean;
				evilpawn: boardCoord;
			end;
		chessState = array[playerType] of playerState;

		gamePeek = ^gamePtr;
		gamePtr = ^gamerecord;
		gameRecord = record
				globals: globalsPeek;
				board: boardType;
				localplayer: playerType;
				playertomove: playerType;
				connectionstate: connectionStateType;
				playstate: playStateType;
				dlg: DialogPtr;
				boardXOrg: integer;
				boardYOrg: integer;
				deaths: array[playerType] of deathList;
				specialstate: chessState;
				resigned: boolean;
				showthemoves: boolean;
				sounds: boolean;
				pawnpos: boardCoord;
			end;

	const
		m_Move = 'm';
		m_Resign = 'r';
		m_PawnChoice = 'p';
	const
		rWaitForWhite = 1128;
		rWaitForBlack = 1129;
		rMoveWhite = 1130;
		rMoveBlack = 1131;

		rWinWhite = 1132;
		rWinBlack = 1133;
		rResignWhite = 1134;
		rResignBlack = 1135;
		rPawnWhite = 1136;
		rPawnBlack = 1137;

		rIconBase = 1000;

		rDeadIcons = 1000;

		rGameDialog = 1000;
		rGameItems = 128;
		dit_board = 1;
		dit_title = 2;
		dit_line = 3;
		dit_status = 4;
		dit_blk_pieces = 5;
		dit_wht_pieces = 6;

		rChessMenu = 1000;
		mid_chess = 1000;
		mit_show_moves = 1;
		mit_sounds = 2;
	{ mit_blank = 3 }
		mit_resign = 4;

implementation

end. { ChessTypes }