unit DerfDraws;

{ DerfBall  Peter Lewis, Oct 1991 }
{ This program and its source are (is? who knows) Povertyware }


interface

	uses
		DerfTypes;

	function Rand (var rnd1, rnd2: longInt; n: integer): longInt;
	procedure DebugNum (s: str255; n: longint);
	procedure GetBoxRect (ggame: gamePeek; var rct: rect; r, c: integer);
	procedure DrawBox (ggame: gamePeek; r: rows; c: cols);
	procedure DrawBox0 (ggame: gamePeek; r, c: integer);
	procedure GetBallRect (h, v: integer; var rct: rect);
	procedure SetBridgeClip (ggame: gamePeek; b: integer);
	procedure DrawDeadBall (ggame: gamePeek; b: integer);
	procedure DrawOutline (ggame: gamePeek);
	procedure UpdateStatus (ggame: gamePeek);
	procedure DrawStatus (ggame: gamePeek);
	procedure DrawBalls (r, b, bls: integer);
	procedure DrawGame (wp: windowPtr; item: integer);

implementation

	function Rand (var rnd1, rnd2: longInt; n: integer): longInt;
		var
			r2: longInt;
	begin
		r2 := BXOR(BOR(BAND(BSR(rnd1, 1), $7FFF), BSL(rnd2, 31)), BSL(rnd1, 12));
		rnd2 := BAND(rnd1, 1);
		rnd1 := BXOR(r2, BAND(BSR(r2, 20), $00000FFF));
		Rand := abs(rnd1) mod n;
	end;

	procedure DebugNum (s: str255; n: longint);
		var
			numstr: str255;
	begin
		NumToString(n, numstr);
		DebugStr(concat(s, numstr));
	end;

	procedure GetBoxRect (ggame: gamePeek; var rct: rect; r, c: integer);
	begin
		with ggame^.globals^, rct do begin
			right := item_rect.left + c * square_width;
			left := right - square_width;
			bottom := item_rect.top + r * square_height;
			top := bottom - square_height;
		end;
	end;

	procedure DrawBox (ggame: gamePeek; r: rows; c: cols);
		var
			dst, src: rect;
			theport: GrafPtr;
	begin
		GetPort(theport);
		with ggame^.globals^ do begin
			GetBoxRect(ggame, dst, r, c);
			if ggame^.board[r, c] = st_None then begin
				PaintRect(dst);
			end
			else begin
				src.top := 0;
				src.bottom := square_height;
				src.right := ord(ggame^.board[r, c]) * square_width;
				src.left := src.right - square_width;
				CopyBits(square_port^.portbits, theport^.portbits, src, dst, srcCopy, nil);
			end;
		end;
	end;

	procedure DrawBox0 (ggame: gamePeek; r, c: integer);
		procedure DrawLine (h1, v1, h2, v2: integer);
		begin
			MoveTo(h1, v1);
			LineTo(h2, v2);
		end;
		var
			dst, rct: rect;
	begin
		if (r > 0) and (r <= row_max) and (c > 0) and (c <= col_max) then
			DrawBox(ggame, r, c)
		else
			with ggame^, globals^ do begin
				GetBoxRect(ggame, dst, r, c);
				rct := ggame^.globals^.item_rect;
				InsetRect(rct, -insetH, -insetV);
				if SectRect(dst, rct, dst) then begin
					PenSize(2, 2);
					if ggame^.wrapcount[c > col_mid] > 0 then
						with dst do begin
							if r < 1 then begin
								DrawLine(left, bottom - 1, right, bottom - 1);
								bottom := bottom - 2;
							end
							else if r > row_max then begin
								DrawLine(left, top, right, top);
								top := top + 2;
							end;
						end;
					EraseRect(dst);
					PenNormal;
				end;
			end;
	end;

	procedure GetBallRect (h, v: integer; var rct: rect);
	begin
		rct.left := h - 3;
		rct.right := h + 3;
		rct.top := v - 3;
		rct.bottom := v + 3;
	end;

	procedure SetBridgeClip (ggame: gamePeek; b: integer);
		var
			rct: rect;
	begin
		with ggame^ do
			if (board[ball[b].row, ball[b].col] = st8) & ((ball[b].side = st_top) or (ball[b].side = st_bottom)) then begin
				GetBoxRect(ggame, rct, ball[b].row, ball[b].col);
				InsetRect(rct, 0, -10);
				if (ball[b].offset <= straight_moves div 2 + 1) <> (ball[b].side = st_bottom) then
					rct.bottom := rct.top + 10 + 6
				else
					rct.top := rct.bottom - 10 - 6;
				ClipRect(rct);
			end;
	end;

	procedure DrawDeadBall (ggame: gamePeek; b: integer);
		var
			rct: rect;
	begin
		with ggame^ do begin
			GetBallRect(ball[b].pos.h, ball[b].pos.v, rct);
			InsetRect(rct, -2, -2);
			PaintOval(rct);
		end;
	end;

	procedure DrawOutline (ggame: gamePeek);
		procedure DoFrameRect (rct: rect);
		begin
			MoveTo(rct.left, rct.top);
			LineTo(rct.right, rct.top);
			MoveTo(rct.left, rct.bottom - 2);
			LineTo(rct.right, rct.bottom - 2);
		end;
		procedure FrameIt (side: boolean);
			var
				rct: rect;
		begin
			rct := ggame^.globals^.item_rect;
			InsetRect(rct, 0, -2);
			with rct do begin
				right := right - 2;
				if side then
					left := (left + right) div 2
				else
					right := (left + right) div 2;
			end;
			if ggame^.wrapcount[side] > 0 then begin
				DoFrameRect(rct);
			end
			else begin
				PenPat(ggame^.globals^.white);
				DoFrameRect(rct);
				PenPat(ggame^.globals^.black);
			end;
		end;
		var
			i: boolean;
	begin
		PenSize(2, 2);
		for i := false to true do
			FrameIt(i);
		PenNormal;
	end;

	procedure UpdateStatus (ggame: gamePeek);
		var
			wid: integer;
		procedure DrawWrap (l, b, n: integer);
			var
				s: str255;
				r: rect;
		begin
			NumToString(n, s);
			r.left := l + wid - StringWidth(' 99');
			r.right := l + wid;
			r.bottom := b + 4;
			r.top := b - 16;
			MoveTo(r.right - StringWidth(s), b);
			EraseRect(r);
			DrawString(s);
		end;
		var
			r: rect;
	begin
		with ggame^, globals^, status_rect do begin
			wid := StringWidth('Wrap Count: 99');
			DrawWrap(left + 24, bottom - 4, wrapcount[false]);
			DrawWrap((left + right) div 2 + 24, bottom - 4, wrapcount[true]);
		end;
	end;

	procedure DrawStatus (ggame: gamePeek);
		var
			wid: integer;
		procedure DrawWrap (l, b: integer; n: integer);
			var
				s: str255;
		begin
			MoveTo(l, b);
			DrawString('Wrap Count:');
			NumToString(n, s);
			MoveTo(l + wid - StringWidth(s), b);
			DrawString(s);
		end;
		procedure DrawBalls (r, b, bls: integer);
			var
				rct: rect;
				i: integer;
		begin
			for i := 1 to bls - 1 do begin
				GetBallRect(r - i * 10, b, rct);
				PaintOval(rct);
			end;
		end;
		var
			r: rect;
	begin
		with ggame^, globals^, status_rect do begin
			EraseRect(status_rect);
			wid := StringWidth('Wrap Count: 99');
			DrawWrap(left + 24, bottom - 4, wrapcount[false]);
			DrawWrap((left + right) div 2 + 24, bottom - 4, wrapcount[true]);
			DrawBalls((left + right) div 2 - 24, bottom - 8, ballcount[false]);
			DrawBalls(right - 24, bottom - 8, ballcount[true]);
		end;
	end;

	procedure DrawGame (wp: windowPtr; item: integer);
		var
			h: handle;
			ggame: gamePeek;
			r: rows;
			c: cols;
			rct: rect;
			b: integer;
	begin
		h := handle(GetWRefCon(wp));
		HLock(h);
		ggame := gamePeek(h^);
		if ggame^.infront or (ggame^.playState <> ps_playing) or (ggame^.connectionState = cs_remote) then begin
			DrawOutline(ggame);
			for r := 1 to row_max do
				for c := 1 to col_max do
					DrawBox(ggame, r, c);
			if ggame^.playstate = ps_won then
				for b := 1 to ball_max do
					DrawDeadBall(ggame, b);
			PenNormal;
		end
		else begin
			rct := ggame^.globals^.item_rect;
			InsetRect(rct, -10, -5);
			EraseRect(rct);
		end;
		DrawStatus(ggame);
		HUnlock(h);
	end;
end.