unit DerfTypes;

{ DerfBall  Peter Lewis, Oct 1991 }
{ This program and its source are (is? who knows) Povertyware }

interface

	const
		slide_count = 8;
		speed = 25;
		my_dialog_item = 1;
		row_max = 10;
		col_max = 20;
		col_mid = col_max div 2;
		width = 2;
		insetH = 5;
		insetV = 3;
		square_width = 24;    { Change me at your peril }
		square_height = 24;	{ ditto }
		straight_moves = 12;
		curved_moves = 9;
		status_offset = insetV;
		status_height = 18;
		initial_wrapcount = 25;
		initial_balls = 5;
		ball_max = 2;

	type
		connectionStateType = (cs_Local, cs_Remote);
		squareType = (st_None, st_Empty, st1, st2, st3, st4, st5, st6, st7, st8, st9);
		ownerType = 0..1;
		sideType = (st_top, st_right, st_bottom, st_left);
		playStateType = (ps_Playing, ps_Won);
		rows0 = 0..row_max;
		cols0 = 0..col_max;
		rows = 1..row_max;
		cols = 1..col_max;
		boardArray = array[rows, cols] of squareType;
		globalsRecord = record
				black: pattern;
				gray: pattern;
				white: pattern;
				item_rect, status_rect, full_rect: rect;
				square_port: grafPtr;
				offs1, offs2: array[0..straight_moves] of integer;
				offc1, offc2: array[0..curved_moves] of integer;
				sideh, sidev: array[sideType] of integer;
			end;
		ballRecord = record
				row: rows;
				col: cols;
				side, out: sideType;
				curved: boolean;
				offset, max: integer;
				time: longInt;
				pos: point;
				dh1, dv1, dh2, dv2: integer;
			end;
		globalsPeek = ^globalsRecord;
		gameRecord = record
				globals: globalsPeek;
				master: boolean;
				board: boardArray;
				space: array[ownerType] of record
						row: rows;
						col: cols;
					end;
				rnd1, rnd2: longInt;
				wrapcount, squarecount, ballcount: array[boolean] of integer;
				ball: array[1..ball_max] of ballRecord;
				playstate: playStateType;
				infront: boolean;
				connectionState: connectionStateType;
			end;
		gamePeek = ^gameRecord;
		restartRecord = record
				s: string[1];
				rnd1: longInt;
				rnd2: longInt;
				xxx: string[53];
			end;

implementation

end.