unit GTW;

{ This is a Joke.  Its not suppose to be historically accurate! :-) }
{ Global Thermonuclear War  Peter Lewis, Oct 1991 }
{ This program and its source are Povertyware }

interface

	uses
		GameTypes;

	procedure Main (var ger: gameEventRecord);

implementation

	const
		my_dialog_item = 11;
		usa_button = 1;
		ussr_button = 2;
		text_item = 3;
		pict_item = 4;
		ussr_item = 5;
		usa_item = 6;
		europe_item = 7;
		nz_item = 8;
		africa_item = 9;
		sa_item = 10;
		start_item = ussr_item;
		finish_item = sa_item;
		defcon_str = 1;
		youlose_str = 2;

	type
		playStateType = (ps_Playing, ps_Lost);
		connectionStateType = (cs_Local, cs_Remote);
		pieceType = (pt_None, pt_ussr, pt_usa);
		globalsPeek = ptr;
		gameRecord = record
				globals: globalsPeek;
				mypiece: pieceType;
				connectionstate: connectionStateType;
				playstate: playStateType;
				scoreStr: str63;
				doit: pieceType;
			end;
		gamePeek = ^gameRecord;

	procedure Fail (s: str255);
	begin
		DebugStr(s);
	end;

	procedure DrawCentreString (r: rect; s: str255);
		var
			finfo: fontInfo;
			h, v: integer;
	begin
		GetFontInfo(finfo);
		with finfo, r do begin
			v := top + ((bottom - top - ascent - descent) div 2) + ascent;
			h := left + ((right - left - StringWidth(s)) div 2);
		end;
		MoveTo(h, v);
		DrawString(s);
	end;

	procedure DrawScore (gwindow: windowPtr; ggame: gamePeek);
		var
			h: handle;
			k: integer;
			r: rect;
	begin
		GetDItem(gwindow, text_item, k, h, r);
		EraseRect(r);
		DrawCentreString(r, ggame^.scoreStr);
	end;

	procedure DrawGame (wp: windowPtr; item: integer);
		var
			ghandle: handle;
			ggame: gamePeek;
	begin
		ghandle := handle(GetWRefCon(wp));
		HLock(ghandle);
		ggame := gamePeek(ghandle^);
		DrawScore(wp, ggame);
		HUnlock(ghandle);
	end;

	procedure Main (var ger: gameEventRecord);
		var
			ggame: gamePeek;
			gwindow: windowPtr;
			ghandle: handle;

		function Opposite (pt: pieceType): pieceType;
		begin
			case pt of
				pt_none: 
					Opposite := pt_none;
				pt_usa: 
					Opposite := pt_ussr;
				pt_ussr: 
					pt := pt_usa;
			end;
		end;

		function GetGlobalString (i: integer): str255;
			var
				s: str255;
		begin
			GetIndString(s, 1000, i);
			GetGlobalString := s;
		end;

		procedure SetMyTurn;
			var
				s: str255;
			procedure MoveButton (item: integer; player: pieceType);
				var
					k: integer;
					h: handle;
					r: rect;
					canplay: boolean;
			begin
				GetDItem(gwindow, item, k, h, r);
				canplay := (ggame^.playstate = ps_playing) and ((ggame^.connectionstate = cs_local) or (ggame^.mypiece = player));
				if canplay <> (r.top < 1000) then begin
					if canplay then
						OffsetRect(r, 0, -2000)
					else
						OffsetRect(r, 0, 2000);
					MoveControl(ControlHandle(h), r.left, r.top);
					SetDItem(gwindow, item, k, h, r);
				end;
			end;
		begin
			ger.myturn := true;
			with ggame^ do begin
				if playstate = ps_Playing then
					s := GetGlobalString(defcon_str)
				else
					s := GetGlobalString(youlose_str);
				if s <> scoreStr then begin
					scoreStr := s;
					DrawScore(gwindow, ggame);
				end;
			end;
			MoveButton(usa_button, pt_usa);
			MoveButton(ussr_button, pt_ussr);
		end;

		procedure NextPlayer;
		begin
			SetMyTurn;
		end;

		procedure SendMove;
		begin
			ger.event := ge_SendMessage;
			ger.message := 'L';
		end;

		procedure Launch (pt: pieceType);
			const
				missile_max = 100;
				fract = 256;
				gravity = 125;
				iters = 40;
			type
				missile = record
						state: (s_dead, s_missile, s_explode);
						iter, total: integer;
						h, v, dh, dv, r, dr: longInt;
					end;
				missileArray = array[1..missile_max] of missile;
			var
				missiles: missileArray;
				rects: array[start_item..finish_item] of rect;
			function Rand (n: integer): integer;
			begin
				Rand := abs(Random) mod n;
			end;
			function RndPt (r: rect): point;
				var
					pt: point;
			begin
				with r, pt do begin
					h := left + Rand(right - left);
					v := top + Rand(bottom - top);
				end;
				RndPt := pt;
			end;
			procedure RandomMissile (src, dst: integer);
				var
					i: integer;
					srcp, dstp: point;
			begin
				srcp := RndPt(rects[src]);
				dstp := RndPt(rects[dst]);
				i := 1;
				while (i < missile_max) and (missiles[i].state <> s_dead) do
					i := i + 1;
				with missiles[i] do
					if state = s_dead then begin
						state := s_missile;
						iter := 0;
						total := iters;
						h := longInt(srcp.h) * fract;
						v := longInt(srcp.v) * fract;
						dh := longInt(dstp.h - srcp.h) * fract div iters;
						dv := (longInt(dstp.v - srcp.v) * fract - longInt(gravity) * iters * (iters + 1) div 2) div iters;
					end;
			end;

			procedure FlyMissile (p: pieceType);
				var
					src, dst: integer;
					r: integer;
			begin
				r := Rand(100);
				if p = pt_usa then begin
					if r < 25 then
						src := europe_item
					else
						src := usa_item;
					dst := ussr_item;
				end
				else begin
					case r of
						0..50: 
							dst := usa_item;
						51..65: 
							dst := europe_item;
						66..72: 
							dst := nz_item;
						73..85: 
							dst := sa_item;
						86..100: 
							dst := africa_item;
					end;
					src := ussr_item;
				end;
				RandomMissile(src, dst);
			end;

			procedure Iterate;
				var
					i: integer;
					rct: rect;
					f: longInt;
			begin
				for i := 1 to missile_max do
					with missiles[i] do
						case state of
							s_missile: 
								begin
								MoveTo(h div fract, v div fract);
								dv := dv + gravity;
								h := h + dh;
								v := v + dv;
								LineTo(h div fract, v div fract);
								iter := iter + 1;
								if iter >= total then begin
									state := s_explode;
									iter := 0;
									total := iters div 2;
									dr := fract;
									r := 2 * fract;
								end;
							end;
							s_explode: 
								begin
								r := r + dr;
								iter := iter + 1;
								if iter = total div 2 then
									dr := -dr
								else begin
									with rct do begin
										top := (v - r) div fract;
										left := (h - r) div fract;
										bottom := (v + r) div fract;
										right := (h + r) div fract;
									end;
									PenMode(patXor);
									PaintOval(rct);
									PenMode(patOr);
									if iter >= total then
										state := s_dead;
								end;
							end;
							otherwise
								;
						end;
				Delay(1, f);
			end;
			var
				i: integer;
				h: handle;
				k: integer;
		begin
			for i := start_item to finish_item do
				GetDItem(gwindow, i, k, h, rects[i]);
			for i := 1 to missile_max do
				missiles[i].state := s_dead;
			for i := 1 to iters div 2 do begin
				FlyMissile(pt);
				Iterate;
			end;
			for i := 1 to iters do begin
				FlyMissile(pt_usa);
				FlyMissile(pt_ussr);
				Iterate;
			end;
			for i := 1 to 2 * iters do begin
				Iterate;
			end;
			ggame^.playstate := ps_Lost;
			SetMyTurn;
		end;

		procedure DoMove (s: str15);
		begin
			if s <> 'L' then
				Fail('Messsage is not L')
			else begin
				Launch(Opposite(ggame^.mypiece));
			end;
		end;

		procedure DoClick (item: integer);
			var
				p: pieceType;
		begin
			p := pt_None;
			if ggame^.playstate = ps_playing then begin
				if item = usa_button then
					p := pt_usa
				else if item = ussr_button then
					p := pt_ussr;
				if ggame^.connectionState = cs_remote then begin
					ggame^.doit := p;
					SendMove;
				end
				else
					Launch(p);
			end;
		end;

		procedure DoIdle;
		begin
			if ggame^.doit <> pt_None then begin
				Launch(ggame^.doit);
				ggame^.doit := pt_None;
			end;
		end;

		procedure InitGame;
			var
				i: integer;
				rct: rect;
				hdl: handle;
		begin
			ger.globals := nil;
			with rct do begin
				hdl := GetResource('DITL', 128);
				if hdl = nil then begin
					Fail('GetResource DITL failed');
					SetRect(rct, 4, 4, 100, 100);
				end
				else
					BlockMove(ptr(longInt(hdl^) + GetHandleSize(hdl) - 10), @rct, SizeOf(rect));
				ger.int1 := left + right; { figure out why :-}
				ger.int2 := top + bottom;
			end;
		end; {proc}

		procedure FinishGame;
		begin
			ger.globals := nil;
		end;

		procedure CommonInit;
			var
				k: integer;
				h: handle;
				rct: rect;
		begin
			GetDItem(gwindow, text_item, k, h, rct);
			SetDItem(gwindow, text_item, k, handle(@DrawGame), rct);
			SetWRefCon(gwindow, longInt(ghandle));
			ggame^.globals := nil;
			ggame^.doit := pt_None;
		end;

		procedure UpdateControls;
		begin
		end;

		procedure RestartGame;
		begin
			with ggame^ do begin
				playstate := ps_Playing;
				SetMyTurn;
			end; {with}
		end;

		procedure GameNew;
		begin
			HUnlock(ghandle);
			SetHandleSize(ghandle, SizeOf(gameRecord));
			HLock(ghandle);
			ggame := gamePeek(ghandle^);
			CommonInit;
			with ggame^ do begin
				connectionstate := cs_Local;
				mypiece := pt_usa;
				RestartGame;
			end; {with}
		end;

		procedure OldGame;
		begin
			CommonInit;
			ggame^.connectionstate := cs_Local;
			SetMyTurn;
			UpdateControls;
		end;

		procedure Swap;
		begin
			with ggame^ do begin
				mypiece := Opposite(mypiece);
				SetMyTurn;
			end; {with}
			UpdateControls;
		end;

		procedure ConnectionLost;
		begin
			with ggame^ do begin
				connectionstate := cs_Local;
				SetMyTurn;
			end; {with}
		end;

		procedure ConnectionMade;
		begin
			with ggame^ do begin
				connectionstate := cs_Remote;
				SetMyTurn;
			end; {with}
		end;

		procedure InvalPort;
			var
				h: handle;
				k: integer;
				r: rect;
		begin
			GetDItem(gwindow, my_dialog_item, k, h, r);
			EraseRect(r);
			InvalRect(r);
		end;

		procedure Restart;
			var
				r: rect;
		begin
			RestartGame;
			InvalPort;
		end;

		procedure MouseDown;
		begin
			DoClick(ger.int1);
		end;

		procedure MessageReceived;
			var
				tmpstr: str255;
				x: longint;
				seq: longint;
				i, j: integer;
		begin
			if ggame^.playstate = ps_playing then
				DoMove(ger.message);
		end;

	begin
		ghandle := ger.game;
		if ghandle <> nil then begin
			HLock(ghandle);
			ggame := gamePeek(ghandle^);
		end;
		GetPort(gwindow);
		case ger.event of
			ge_InitRuleBook: 
				InitGame;
			ge_FinishRuleBook: 
				FinishGame;
			ge_NewGame: 
				GameNew;
			ge_OldGame: 
				OldGame;
			ge_ConnectionLost: 
				ConnectionLost;
			ge_ConnectionMade: 
				ConnectionMade;
			ge_MessageReceived: 
				MessageReceived;
			ge_Idle: 
				DoIdle;
			ge_MouseDown: 
				MouseDown;
			ge_Swap: 
				Swap;
			ge_Restart: 
				Restart;
			otherwise
		end;
		if ghandle <> nil then
			HUnlock(ghandle);
	end;

end.